/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// DestinationsAwsMariaApiService DestinationsAwsMariaApi service
type DestinationsAwsMariaApiService service

type ApiAppDestinationAwsMariaAwsMariaDestinationActionAuthorizationRequest struct {
	ctx        context.Context
	ApiService *DestinationsAwsMariaApiService
}

func (r ApiAppDestinationAwsMariaAwsMariaDestinationActionAuthorizationRequest) Execute() ([]ActionAuthorizationResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationAwsMariaAwsMariaDestinationActionAuthorizationExecute(r)
}

/*
AppDestinationAwsMariaAwsMariaDestinationActionAuthorization List of authorization objects

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationAwsMariaAwsMariaDestinationActionAuthorizationRequest
*/
func (a *DestinationsAwsMariaApiService) AppDestinationAwsMariaAwsMariaDestinationActionAuthorization(ctx context.Context) ApiAppDestinationAwsMariaAwsMariaDestinationActionAuthorizationRequest {
	return ApiAppDestinationAwsMariaAwsMariaDestinationActionAuthorizationRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []ActionAuthorizationResponseInner
func (a *DestinationsAwsMariaApiService) AppDestinationAwsMariaAwsMariaDestinationActionAuthorizationExecute(r ApiAppDestinationAwsMariaAwsMariaDestinationActionAuthorizationRequest) ([]ActionAuthorizationResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodGet
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []ActionAuthorizationResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsAwsMariaApiService.AppDestinationAwsMariaAwsMariaDestinationActionAuthorization")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/aws_maria/actions/authorization"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationAwsMariaAwsMariaDestinationActionTlsRequest struct {
	ctx        context.Context
	ApiService *DestinationsAwsMariaApiService
}

func (r ApiAppDestinationAwsMariaAwsMariaDestinationActionTlsRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationAwsMariaAwsMariaDestinationActionTlsExecute(r)
}

/*
AppDestinationAwsMariaAwsMariaDestinationActionTls List of TLS options

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationAwsMariaAwsMariaDestinationActionTlsRequest
*/
func (a *DestinationsAwsMariaApiService) AppDestinationAwsMariaAwsMariaDestinationActionTls(ctx context.Context) ApiAppDestinationAwsMariaAwsMariaDestinationActionTlsRequest {
	return ApiAppDestinationAwsMariaAwsMariaDestinationActionTlsRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *DestinationsAwsMariaApiService) AppDestinationAwsMariaAwsMariaDestinationActionTlsExecute(r ApiAppDestinationAwsMariaAwsMariaDestinationActionTlsRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodGet
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsAwsMariaApiService.AppDestinationAwsMariaAwsMariaDestinationActionTls")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/aws_maria/actions/tls"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationAwsMariaAwsMariaDestinationActionWriteModesRequest struct {
	ctx                                                              context.Context
	ApiService                                                       *DestinationsAwsMariaApiService
	appDestinationOneDriveOneDriveDestinationActionWriteModesRequest *AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest
}

func (r ApiAppDestinationAwsMariaAwsMariaDestinationActionWriteModesRequest) AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest(appDestinationOneDriveOneDriveDestinationActionWriteModesRequest AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest) ApiAppDestinationAwsMariaAwsMariaDestinationActionWriteModesRequest {
	r.appDestinationOneDriveOneDriveDestinationActionWriteModesRequest = &appDestinationOneDriveOneDriveDestinationActionWriteModesRequest
	return r
}

func (r ApiAppDestinationAwsMariaAwsMariaDestinationActionWriteModesRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationAwsMariaAwsMariaDestinationActionWriteModesExecute(r)
}

/*
AppDestinationAwsMariaAwsMariaDestinationActionWriteModes List of write modes

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationAwsMariaAwsMariaDestinationActionWriteModesRequest
*/
func (a *DestinationsAwsMariaApiService) AppDestinationAwsMariaAwsMariaDestinationActionWriteModes(ctx context.Context) ApiAppDestinationAwsMariaAwsMariaDestinationActionWriteModesRequest {
	return ApiAppDestinationAwsMariaAwsMariaDestinationActionWriteModesRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *DestinationsAwsMariaApiService) AppDestinationAwsMariaAwsMariaDestinationActionWriteModesExecute(r ApiAppDestinationAwsMariaAwsMariaDestinationActionWriteModesRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsAwsMariaApiService.AppDestinationAwsMariaAwsMariaDestinationActionWriteModes")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/aws_maria/actions/writeModes"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appDestinationOneDriveOneDriveDestinationActionWriteModesRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationAwsMariaAwsMariaDestinationCreateRequest struct {
	ctx                 context.Context
	ApiService          *DestinationsAwsMariaApiService
	mySQLStorageRequest *MySQLStorageRequest
}

//
func (r ApiAppDestinationAwsMariaAwsMariaDestinationCreateRequest) MySQLStorageRequest(mySQLStorageRequest MySQLStorageRequest) ApiAppDestinationAwsMariaAwsMariaDestinationCreateRequest {
	r.mySQLStorageRequest = &mySQLStorageRequest
	return r
}

func (r ApiAppDestinationAwsMariaAwsMariaDestinationCreateRequest) Execute() (*AwsMariaDestination, *http.Response, error) {
	return r.ApiService.AppDestinationAwsMariaAwsMariaDestinationCreateExecute(r)
}

/*
AppDestinationAwsMariaAwsMariaDestinationCreate Create destination

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationAwsMariaAwsMariaDestinationCreateRequest
*/
func (a *DestinationsAwsMariaApiService) AppDestinationAwsMariaAwsMariaDestinationCreate(ctx context.Context) ApiAppDestinationAwsMariaAwsMariaDestinationCreateRequest {
	return ApiAppDestinationAwsMariaAwsMariaDestinationCreateRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return AwsMariaDestination
func (a *DestinationsAwsMariaApiService) AppDestinationAwsMariaAwsMariaDestinationCreateExecute(r ApiAppDestinationAwsMariaAwsMariaDestinationCreateRequest) (*AwsMariaDestination, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *AwsMariaDestination
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsAwsMariaApiService.AppDestinationAwsMariaAwsMariaDestinationCreate")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/aws_maria"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.mySQLStorageRequest == nil {
		return localVarReturnValue, nil, reportError("mySQLStorageRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.mySQLStorageRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
